-- 20.07.2006, Denis Povshedny, denikin@subtleware.com
-- import csv file. Delimiter hardcoded as comma

local fcsv, errmsg = io.open ( "csvImport.txt", "r" )
assert( fcsv, errmsg )
local data = fcsv:read( "*a" )
fcsv:close()

print( "\nsource data:\n", data )

-- NoSpaces, todo: add tab replacement
data = string.gsub( data, " ", "" )
print( "\nremoved spaces\n", data )

-- transform start/end of lines
data = "{" .. string.gsub( data, "\n", "},\n{" ) .. "}"
print( "\nnewline transformed\n", data )

-- process NULLs
local nRepl = 0
repeat
	data, nRepl = string.gsub( data, "{,", "{nil," )
until nRepl == 0
repeat
	data, nRepl = string.gsub( data, ",}", ",nil}" )
until nRepl == 0
repeat
	data, nRepl = string.gsub( data, ",,", ",nil," )
until nRepl == 0
print( "\nNULLs transformed\n", data )

-- wrap and run
local csv = assert( loadstring( "return {\n" .. data .. "}" ) ) () 

print( "\nloaded, result is:" )
for i, v in csv do
	for ii = 1, 4 do
		print( i, ii, v[ii] )
	end	
end